﻿// <auto-generated />
using System;
using MOD.Repository.Contexts;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;

namespace MOD.Repository.Migrations
{
    [DbContext(typeof(ModContext))]
    [Migration("20191107114902_initialmigration")]
    partial class initialmigration
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "2.1.3-rtm-32065")
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("MOD.Models.Models.MentorCalendar", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<DateTime>("EndDate");

                    b.Property<int>("MentorId");

                    b.Property<DateTime>("StartDate");

                    b.HasKey("Id");

                    b.HasIndex("MentorId");

                    b.ToTable("MentorCalendars");
                });

            modelBuilder.Entity("MOD.Models.Models.MentorSkill", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int>("FacilitiesOffered");

                    b.Property<int>("MentorId");

                    b.Property<int>("SelfRating");

                    b.Property<int>("SkillId");

                    b.Property<int>("TrainingsDelivered");

                    b.Property<int>("YearsOfExperience");

                    b.HasKey("Id");

                    b.HasIndex("MentorId");

                    b.ToTable("MentorSkills");
                });

            modelBuilder.Entity("MOD.Models.Models.Payment", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<decimal>("Amount");

                    b.Property<int>("MentorId");

                    b.Property<DateTime>("PaymentDate");

                    b.Property<string>("Remarks");

                    b.Property<int>("TrainingId");

                    b.Property<string>("TxnType");

                    b.HasKey("Id");

                    b.HasIndex("MentorId");

                    b.HasIndex("TrainingId")
                        .IsUnique();

                    b.ToTable("Payments");
                });

            modelBuilder.Entity("MOD.Models.Models.Role", b =>
                {
                    b.Property<int>("RoleId")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("RoleDesc");

                    b.Property<string>("RoleName");

                    b.HasKey("RoleId");

                    b.ToTable("Roles");
                });

            modelBuilder.Entity("MOD.Models.Models.Technology", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int>("Duration");

                    b.Property<string>("Name");

                    b.Property<string>("Prerequisites");

                    b.Property<string>("TermsOfConditions");

                    b.HasKey("Id");

                    b.ToTable("Technologies");
                });

            modelBuilder.Entity("MOD.Models.Models.Training", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<decimal>("AmountReceived");

                    b.Property<DateTime>("EndDate");

                    b.Property<int>("MentorId");

                    b.Property<int>("PaymentId");

                    b.Property<int>("Progress");

                    b.Property<int>("Rating");

                    b.Property<int>("SkillId");

                    b.Property<DateTime>("StartDate");

                    b.Property<string>("Status");

                    b.Property<int?>("TrainingId");

                    b.Property<int>("UserId");

                    b.HasKey("Id");

                    b.HasIndex("MentorId");

                    b.ToTable("Trainings");
                });

            modelBuilder.Entity("MOD.Models.Models.User", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<bool>("Active");

                    b.Property<string>("ContactNumber");

                    b.Property<string>("Discriminator")
                        .IsRequired();

                    b.Property<string>("FirstName");

                    b.Property<bool>("ForceResetPassword");

                    b.Property<DateTime>("LastLoginDate");

                    b.Property<string>("LastName");

                    b.Property<string>("Password");

                    b.Property<string>("RegCode");

                    b.Property<DateTime>("RegDateTime");

                    b.Property<int>("RoleId");

                    b.Property<string>("UserName");

                    b.HasKey("Id");

                    b.HasIndex("RoleId");

                    b.ToTable("Users");

                    b.HasDiscriminator<string>("Discriminator").HasValue("User");
                });

            modelBuilder.Entity("MOD.Models.Models.Mentor", b =>
                {
                    b.HasBaseType("MOD.Models.Models.User");

                    b.Property<string>("LinkedUrl");

                    b.Property<int>("YearsOfExperience");

                    b.ToTable("Mentor");

                    b.HasDiscriminator().HasValue("Mentor");
                });

            modelBuilder.Entity("MOD.Models.Models.MentorCalendar", b =>
                {
                    b.HasOne("MOD.Models.Models.Mentor", "Mentor")
                        .WithMany("MentorCalendars")
                        .HasForeignKey("MentorId")
                        .HasConstraintName("ForeignKey_MentorCalendar_Mentor")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("MOD.Models.Models.MentorSkill", b =>
                {
                    b.HasOne("MOD.Models.Models.Mentor", "Mentor")
                        .WithMany("MentorSkills")
                        .HasForeignKey("MentorId")
                        .HasConstraintName("ForeignKey_MentorSkill_Mentor")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("MOD.Models.Models.Payment", b =>
                {
                    b.HasOne("MOD.Models.Models.Mentor", "Mentor")
                        .WithMany("MentorPayments")
                        .HasForeignKey("MentorId")
                        .HasConstraintName("ForeignKey_Payment_Mentor")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("MOD.Models.Models.Training", "Training")
                        .WithOne("Payment")
                        .HasForeignKey("MOD.Models.Models.Payment", "TrainingId")
                        .HasConstraintName("ForeignKey_Training_Payment");
                });

            modelBuilder.Entity("MOD.Models.Models.Training", b =>
                {
                    b.HasOne("MOD.Models.Models.Mentor", "Mentor")
                        .WithMany("MentorTrainings")
                        .HasForeignKey("MentorId")
                        .HasConstraintName("ForeignKey_Training_Mentor")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("MOD.Models.Models.User", b =>
                {
                    b.HasOne("MOD.Models.Models.Role", "Role")
                        .WithMany("Users")
                        .HasForeignKey("RoleId")
                        .HasConstraintName("ForeignKey_User_Role")
                        .OnDelete(DeleteBehavior.Cascade);
                });
#pragma warning restore 612, 618
        }
    }
}
